<!-- HTML header for doxygen 1.8.9.1-->
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.11"/>
<meta name="robots" content="NOINDEX, NOFOLLOW" /> <!-- Prevent indexing by search engines -->
<title>ARM Compute Library: src/core/CL/cl_kernels/non_linear_filter5x5.cl Source File</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="navtree.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="resize.js"></script>
<script type="text/javascript" src="navtreedata.js"></script>
<script type="text/javascript" src="navtree.js"></script>
<script type="text/javascript">
  $(document).ready(initResizable);
  $(window).load(resizeHeight);
</script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { init_search(); });
</script>
<script type="text/x-mathjax-config">
  MathJax.Hub.Config({
    extensions: ["tex2jax.js"],
    jax: ["input/TeX","output/HTML-CSS"],
});
</script><script type="text/javascript" src="http://cdn.mathjax.org/mathjax/latest/MathJax.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">ARM Compute Library
   &#160;<span id="projectnumber">17.04</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.11 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.xhtml"><span>Main&#160;Page</span></a></li>
      <li><a href="namespaces.xhtml"><span>Namespaces</span></a></li>
      <li><a href="annotated.xhtml"><span>Data&#160;Structures</span></a></li>
      <li class="current"><a href="files.xhtml"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="files.xhtml"><span>File&#160;List</span></a></li>
      <li><a href="globals.xhtml"><span>Globals</span></a></li>
    </ul>
  </div>
</div><!-- top -->
<div id="side-nav" class="ui-resizable side-nav-resizable">
  <div id="nav-tree">
    <div id="nav-tree-contents">
      <div id="nav-sync" class="sync"></div>
    </div>
  </div>
  <div id="splitbar" style="-moz-user-select:none;" 
       class="ui-resizable-handle">
  </div>
</div>
<script type="text/javascript">
$(document).ready(function(){initNavTree('non__linear__filter5x5_8cl_source.xhtml','');});
</script>
<div id="doc-content">
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

<div class="header">
  <div class="headertitle">
<div class="title">non_linear_filter5x5.cl</div>  </div>
</div><!--header-->
<div class="contents">
<a href="non__linear__filter5x5_8cl.xhtml">Go to the documentation of this file.</a><div class="fragment"><div class="line"><a name="l00001"></a><span class="lineno">    1</span>&#160;<span class="comment">/*</span></div><div class="line"><a name="l00002"></a><span class="lineno">    2</span>&#160;<span class="comment"> * Copyright (c) 2016, 2017 ARM Limited.</span></div><div class="line"><a name="l00003"></a><span class="lineno">    3</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00004"></a><span class="lineno">    4</span>&#160;<span class="comment"> * SPDX-License-Identifier: MIT</span></div><div class="line"><a name="l00005"></a><span class="lineno">    5</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00006"></a><span class="lineno">    6</span>&#160;<span class="comment"> * Permission is hereby granted, free of charge, to any person obtaining a copy</span></div><div class="line"><a name="l00007"></a><span class="lineno">    7</span>&#160;<span class="comment"> * of this software and associated documentation files (the &quot;Software&quot;), to</span></div><div class="line"><a name="l00008"></a><span class="lineno">    8</span>&#160;<span class="comment"> * deal in the Software without restriction, including without limitation the</span></div><div class="line"><a name="l00009"></a><span class="lineno">    9</span>&#160;<span class="comment"> * rights to use, copy, modify, merge, publish, distribute, sublicense, and/or</span></div><div class="line"><a name="l00010"></a><span class="lineno">   10</span>&#160;<span class="comment"> * sell copies of the Software, and to permit persons to whom the Software is</span></div><div class="line"><a name="l00011"></a><span class="lineno">   11</span>&#160;<span class="comment"> * furnished to do so, subject to the following conditions:</span></div><div class="line"><a name="l00012"></a><span class="lineno">   12</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00013"></a><span class="lineno">   13</span>&#160;<span class="comment"> * The above copyright notice and this permission notice shall be included in all</span></div><div class="line"><a name="l00014"></a><span class="lineno">   14</span>&#160;<span class="comment"> * copies or substantial portions of the Software.</span></div><div class="line"><a name="l00015"></a><span class="lineno">   15</span>&#160;<span class="comment"> *</span></div><div class="line"><a name="l00016"></a><span class="lineno">   16</span>&#160;<span class="comment"> * THE SOFTWARE IS PROVIDED &quot;AS IS&quot;, WITHOUT WARRANTY OF ANY KIND, EXPRESS OR</span></div><div class="line"><a name="l00017"></a><span class="lineno">   17</span>&#160;<span class="comment"> * IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,</span></div><div class="line"><a name="l00018"></a><span class="lineno">   18</span>&#160;<span class="comment"> * FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE</span></div><div class="line"><a name="l00019"></a><span class="lineno">   19</span>&#160;<span class="comment"> * AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER</span></div><div class="line"><a name="l00020"></a><span class="lineno">   20</span>&#160;<span class="comment"> * LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,</span></div><div class="line"><a name="l00021"></a><span class="lineno">   21</span>&#160;<span class="comment"> * OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE</span></div><div class="line"><a name="l00022"></a><span class="lineno">   22</span>&#160;<span class="comment"> * SOFTWARE.</span></div><div class="line"><a name="l00023"></a><span class="lineno">   23</span>&#160;<span class="comment"> */</span></div><div class="line"><a name="l00024"></a><span class="lineno">   24</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="helpers_8h.xhtml">helpers.h</a>&quot;</span></div><div class="line"><a name="l00025"></a><span class="lineno">   25</span>&#160;<span class="preprocessor">#include &quot;<a class="code" href="non__linear__filter__helpers_8h.xhtml">non_linear_filter_helpers.h</a>&quot;</span></div><div class="line"><a name="l00026"></a><span class="lineno">   26</span>&#160;</div><div class="line"><a name="l00027"></a><span class="lineno">   27</span>&#160;<span class="comment">// Sorting networks below were generated using http://pages.ripco.net/~jgamble/nw.html</span></div><div class="line"><a name="l00028"></a><span class="lineno">   28</span>&#160;</div><div class="line"><a name="l00039"></a><span class="lineno"><a class="line" href="non__linear__filter5x5_8cl.xhtml#a8a1966a000958e0d48cdc182da9c8bdf">   39</a></span>&#160;<span class="keyword">inline</span> uchar8 <a class="code" href="non__linear__filter5x5_8cl.xhtml#a8a1966a000958e0d48cdc182da9c8bdf">median_disk5x5</a>(uchar16 top2, uchar16 top, uchar16 middle, uchar16 bottom, uchar16 bottom2)</div><div class="line"><a name="l00040"></a><span class="lineno">   40</span>&#160;{</div><div class="line"><a name="l00041"></a><span class="lineno">   41</span>&#160;    uchar8 p0  = top2.s01234567;</div><div class="line"><a name="l00042"></a><span class="lineno">   42</span>&#160;    uchar8 p1  = top2.s12345678;</div><div class="line"><a name="l00043"></a><span class="lineno">   43</span>&#160;    uchar8 p2  = top2.s23456789;</div><div class="line"><a name="l00044"></a><span class="lineno">   44</span>&#160;    uchar8 p3  = top.s01234567;</div><div class="line"><a name="l00045"></a><span class="lineno">   45</span>&#160;    uchar8 p4  = top.s12345678;</div><div class="line"><a name="l00046"></a><span class="lineno">   46</span>&#160;    uchar8 p5  = top.s23456789;</div><div class="line"><a name="l00047"></a><span class="lineno">   47</span>&#160;    uchar8 p6  = top.s3456789A;</div><div class="line"><a name="l00048"></a><span class="lineno">   48</span>&#160;    uchar8 p7  = top.s456789AB;</div><div class="line"><a name="l00049"></a><span class="lineno">   49</span>&#160;    uchar8 p8  = middle.s01234567;</div><div class="line"><a name="l00050"></a><span class="lineno">   50</span>&#160;    uchar8 p9  = middle.s12345678;</div><div class="line"><a name="l00051"></a><span class="lineno">   51</span>&#160;    uchar8 p10 = middle.s23456789;</div><div class="line"><a name="l00052"></a><span class="lineno">   52</span>&#160;    uchar8 p11 = middle.s3456789A;</div><div class="line"><a name="l00053"></a><span class="lineno">   53</span>&#160;    uchar8 p12 = middle.s456789AB;</div><div class="line"><a name="l00054"></a><span class="lineno">   54</span>&#160;    uchar8 p13 = bottom.s01234567;</div><div class="line"><a name="l00055"></a><span class="lineno">   55</span>&#160;    uchar8 p14 = bottom.s12345678;</div><div class="line"><a name="l00056"></a><span class="lineno">   56</span>&#160;    uchar8 p15 = bottom.s23456789;</div><div class="line"><a name="l00057"></a><span class="lineno">   57</span>&#160;    uchar8 p16 = bottom.s3456789A;</div><div class="line"><a name="l00058"></a><span class="lineno">   58</span>&#160;    uchar8 p17 = bottom.s456789AB;</div><div class="line"><a name="l00059"></a><span class="lineno">   59</span>&#160;    uchar8 p18 = bottom2.s01234567;</div><div class="line"><a name="l00060"></a><span class="lineno">   60</span>&#160;    uchar8 p19 = bottom2.s12345678;</div><div class="line"><a name="l00061"></a><span class="lineno">   61</span>&#160;    uchar8 p20 = bottom2.s23456789;</div><div class="line"><a name="l00062"></a><span class="lineno">   62</span>&#160;</div><div class="line"><a name="l00063"></a><span class="lineno">   63</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p1);</div><div class="line"><a name="l00064"></a><span class="lineno">   64</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p3);</div><div class="line"><a name="l00065"></a><span class="lineno">   65</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p5);</div><div class="line"><a name="l00066"></a><span class="lineno">   66</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p7);</div><div class="line"><a name="l00067"></a><span class="lineno">   67</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p8, p9);</div><div class="line"><a name="l00068"></a><span class="lineno">   68</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p11);</div><div class="line"><a name="l00069"></a><span class="lineno">   69</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p12, p13);</div><div class="line"><a name="l00070"></a><span class="lineno">   70</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p14, p15);</div><div class="line"><a name="l00071"></a><span class="lineno">   71</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p16, p17);</div><div class="line"><a name="l00072"></a><span class="lineno">   72</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p18, p19);</div><div class="line"><a name="l00073"></a><span class="lineno">   73</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p2);</div><div class="line"><a name="l00074"></a><span class="lineno">   74</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p3);</div><div class="line"><a name="l00075"></a><span class="lineno">   75</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p6);</div><div class="line"><a name="l00076"></a><span class="lineno">   76</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p7);</div><div class="line"><a name="l00077"></a><span class="lineno">   77</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p8, p10);</div><div class="line"><a name="l00078"></a><span class="lineno">   78</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p11);</div><div class="line"><a name="l00079"></a><span class="lineno">   79</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p12, p14);</div><div class="line"><a name="l00080"></a><span class="lineno">   80</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p15);</div><div class="line"><a name="l00081"></a><span class="lineno">   81</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p16, p18);</div><div class="line"><a name="l00082"></a><span class="lineno">   82</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p17, p19);</div><div class="line"><a name="l00083"></a><span class="lineno">   83</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00084"></a><span class="lineno">   84</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p6);</div><div class="line"><a name="l00085"></a><span class="lineno">   85</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p4);</div><div class="line"><a name="l00086"></a><span class="lineno">   86</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p7);</div><div class="line"><a name="l00087"></a><span class="lineno">   87</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p10);</div><div class="line"><a name="l00088"></a><span class="lineno">   88</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p14);</div><div class="line"><a name="l00089"></a><span class="lineno">   89</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p8, p12);</div><div class="line"><a name="l00090"></a><span class="lineno">   90</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p11, p15);</div><div class="line"><a name="l00091"></a><span class="lineno">   91</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p17, p18);</div><div class="line"><a name="l00092"></a><span class="lineno">   92</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p16, p20);</div><div class="line"><a name="l00093"></a><span class="lineno">   93</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p5);</div><div class="line"><a name="l00094"></a><span class="lineno">   94</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p6);</div><div class="line"><a name="l00095"></a><span class="lineno">   95</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p13);</div><div class="line"><a name="l00096"></a><span class="lineno">   96</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p14);</div><div class="line"><a name="l00097"></a><span class="lineno">   97</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p8);</div><div class="line"><a name="l00098"></a><span class="lineno">   98</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p15);</div><div class="line"><a name="l00099"></a><span class="lineno">   99</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p17, p20);</div><div class="line"><a name="l00100"></a><span class="lineno">  100</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p4);</div><div class="line"><a name="l00101"></a><span class="lineno">  101</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p6);</div><div class="line"><a name="l00102"></a><span class="lineno">  102</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p12);</div><div class="line"><a name="l00103"></a><span class="lineno">  103</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p11, p14);</div><div class="line"><a name="l00104"></a><span class="lineno">  104</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p18, p20);</div><div class="line"><a name="l00105"></a><span class="lineno">  105</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p16);</div><div class="line"><a name="l00106"></a><span class="lineno">  106</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p4);</div><div class="line"><a name="l00107"></a><span class="lineno">  107</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p5);</div><div class="line"><a name="l00108"></a><span class="lineno">  108</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p12);</div><div class="line"><a name="l00109"></a><span class="lineno">  109</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p11, p13);</div><div class="line"><a name="l00110"></a><span class="lineno">  110</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p9);</div><div class="line"><a name="l00111"></a><span class="lineno">  111</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p14);</div><div class="line"><a name="l00112"></a><span class="lineno">  112</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p19, p20);</div><div class="line"><a name="l00113"></a><span class="lineno">  113</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p4);</div><div class="line"><a name="l00114"></a><span class="lineno">  114</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p11, p12);</div><div class="line"><a name="l00115"></a><span class="lineno">  115</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p8);</div><div class="line"><a name="l00116"></a><span class="lineno">  116</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p10);</div><div class="line"><a name="l00117"></a><span class="lineno">  117</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p13);</div><div class="line"><a name="l00118"></a><span class="lineno">  118</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p14);</div><div class="line"><a name="l00119"></a><span class="lineno">  119</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p11);</div><div class="line"><a name="l00120"></a><span class="lineno">  120</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p8);</div><div class="line"><a name="l00121"></a><span class="lineno">  121</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p12);</div><div class="line"><a name="l00122"></a><span class="lineno">  122</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p13);</div><div class="line"><a name="l00123"></a><span class="lineno">  123</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p17);</div><div class="line"><a name="l00124"></a><span class="lineno">  124</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p10);</div><div class="line"><a name="l00125"></a><span class="lineno">  125</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p12);</div><div class="line"><a name="l00126"></a><span class="lineno">  126</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p16);</div><div class="line"><a name="l00127"></a><span class="lineno">  127</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p18);</div><div class="line"><a name="l00128"></a><span class="lineno">  128</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p9);</div><div class="line"><a name="l00129"></a><span class="lineno">  129</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p12);</div><div class="line"><a name="l00130"></a><span class="lineno">  130</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p16);</div><div class="line"><a name="l00131"></a><span class="lineno">  131</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p8);</div><div class="line"><a name="l00132"></a><span class="lineno">  132</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p12);</div><div class="line"><a name="l00133"></a><span class="lineno">  133</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p9);</div><div class="line"><a name="l00134"></a><span class="lineno">  134</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p10);</div><div class="line"><a name="l00135"></a><span class="lineno">  135</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p8);</div><div class="line"><a name="l00136"></a><span class="lineno">  136</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p11);</div><div class="line"><a name="l00137"></a><span class="lineno">  137</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p19);</div><div class="line"><a name="l00138"></a><span class="lineno">  138</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p8);</div><div class="line"><a name="l00139"></a><span class="lineno">  139</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p10);</div><div class="line"><a name="l00140"></a><span class="lineno">  140</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p18);</div><div class="line"><a name="l00141"></a><span class="lineno">  141</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p20);</div><div class="line"><a name="l00142"></a><span class="lineno">  142</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p8);</div><div class="line"><a name="l00143"></a><span class="lineno">  143</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p9);</div><div class="line"><a name="l00144"></a><span class="lineno">  144</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p17);</div><div class="line"><a name="l00145"></a><span class="lineno">  145</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p20);</div><div class="line"><a name="l00146"></a><span class="lineno">  146</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00147"></a><span class="lineno">  147</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p16);</div><div class="line"><a name="l00148"></a><span class="lineno">  148</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p20);</div><div class="line"><a name="l00149"></a><span class="lineno">  149</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p17);</div><div class="line"><a name="l00150"></a><span class="lineno">  150</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p20);</div><div class="line"><a name="l00151"></a><span class="lineno">  151</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p16);</div><div class="line"><a name="l00152"></a><span class="lineno">  152</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p18);</div><div class="line"><a name="l00153"></a><span class="lineno">  153</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p16);</div><div class="line"><a name="l00154"></a><span class="lineno">  154</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p19);</div><div class="line"><a name="l00155"></a><span class="lineno">  155</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p18);</div><div class="line"><a name="l00156"></a><span class="lineno">  156</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p16);</div><div class="line"><a name="l00157"></a><span class="lineno">  157</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p17);</div><div class="line"><a name="l00158"></a><span class="lineno">  158</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p18);</div><div class="line"><a name="l00159"></a><span class="lineno">  159</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p16);</div><div class="line"><a name="l00160"></a><span class="lineno">  160</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p17);</div><div class="line"><a name="l00161"></a><span class="lineno">  161</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p8, p16);</div><div class="line"><a name="l00162"></a><span class="lineno">  162</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p16);</div><div class="line"><a name="l00163"></a><span class="lineno">  163</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p16);</div><div class="line"><a name="l00164"></a><span class="lineno">  164</span>&#160;</div><div class="line"><a name="l00165"></a><span class="lineno">  165</span>&#160;    <span class="keywordflow">return</span> p10;</div><div class="line"><a name="l00166"></a><span class="lineno">  166</span>&#160;}</div><div class="line"><a name="l00167"></a><span class="lineno">  167</span>&#160;</div><div class="line"><a name="l00178"></a><span class="lineno"><a class="line" href="non__linear__filter5x5_8cl.xhtml#ac943e4049581c4aa48abecb270d36fd8">  178</a></span>&#160;<span class="keyword">inline</span> uchar8 <a class="code" href="non__linear__filter5x5_8cl.xhtml#ac943e4049581c4aa48abecb270d36fd8">median_box5x5</a>(uchar16 top2, uchar16 top, uchar16 middle, uchar16 bottom, uchar16 bottom2)</div><div class="line"><a name="l00179"></a><span class="lineno">  179</span>&#160;{</div><div class="line"><a name="l00180"></a><span class="lineno">  180</span>&#160;    uchar8 p0  = top2.s01234567;</div><div class="line"><a name="l00181"></a><span class="lineno">  181</span>&#160;    uchar8 p1  = top2.s12345678;</div><div class="line"><a name="l00182"></a><span class="lineno">  182</span>&#160;    uchar8 p2  = top2.s23456789;</div><div class="line"><a name="l00183"></a><span class="lineno">  183</span>&#160;    uchar8 p3  = top2.s3456789A;</div><div class="line"><a name="l00184"></a><span class="lineno">  184</span>&#160;    uchar8 p4  = top2.s456789AB;</div><div class="line"><a name="l00185"></a><span class="lineno">  185</span>&#160;    uchar8 p5  = top.s01234567;</div><div class="line"><a name="l00186"></a><span class="lineno">  186</span>&#160;    uchar8 p6  = top.s12345678;</div><div class="line"><a name="l00187"></a><span class="lineno">  187</span>&#160;    uchar8 p7  = top.s23456789;</div><div class="line"><a name="l00188"></a><span class="lineno">  188</span>&#160;    uchar8 p8  = top.s3456789A;</div><div class="line"><a name="l00189"></a><span class="lineno">  189</span>&#160;    uchar8 p9  = top.s456789AB;</div><div class="line"><a name="l00190"></a><span class="lineno">  190</span>&#160;    uchar8 p10 = middle.s01234567;</div><div class="line"><a name="l00191"></a><span class="lineno">  191</span>&#160;    uchar8 p11 = middle.s12345678;</div><div class="line"><a name="l00192"></a><span class="lineno">  192</span>&#160;    uchar8 p12 = middle.s23456789;</div><div class="line"><a name="l00193"></a><span class="lineno">  193</span>&#160;    uchar8 p13 = middle.s3456789A;</div><div class="line"><a name="l00194"></a><span class="lineno">  194</span>&#160;    uchar8 p14 = middle.s456789AB;</div><div class="line"><a name="l00195"></a><span class="lineno">  195</span>&#160;    uchar8 p15 = bottom.s01234567;</div><div class="line"><a name="l00196"></a><span class="lineno">  196</span>&#160;    uchar8 p16 = bottom.s12345678;</div><div class="line"><a name="l00197"></a><span class="lineno">  197</span>&#160;    uchar8 p17 = bottom.s23456789;</div><div class="line"><a name="l00198"></a><span class="lineno">  198</span>&#160;    uchar8 p18 = bottom.s3456789A;</div><div class="line"><a name="l00199"></a><span class="lineno">  199</span>&#160;    uchar8 p19 = bottom.s456789AB;</div><div class="line"><a name="l00200"></a><span class="lineno">  200</span>&#160;    uchar8 p20 = bottom2.s01234567;</div><div class="line"><a name="l00201"></a><span class="lineno">  201</span>&#160;    uchar8 p21 = bottom2.s12345678;</div><div class="line"><a name="l00202"></a><span class="lineno">  202</span>&#160;    uchar8 p22 = bottom2.s23456789;</div><div class="line"><a name="l00203"></a><span class="lineno">  203</span>&#160;    uchar8 p23 = bottom2.s3456789A;</div><div class="line"><a name="l00204"></a><span class="lineno">  204</span>&#160;    uchar8 p24 = bottom2.s456789AB;</div><div class="line"><a name="l00205"></a><span class="lineno">  205</span>&#160;</div><div class="line"><a name="l00206"></a><span class="lineno">  206</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00207"></a><span class="lineno">  207</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p1);</div><div class="line"><a name="l00208"></a><span class="lineno">  208</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00209"></a><span class="lineno">  209</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p5);</div><div class="line"><a name="l00210"></a><span class="lineno">  210</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p4);</div><div class="line"><a name="l00211"></a><span class="lineno">  211</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p5);</div><div class="line"><a name="l00212"></a><span class="lineno">  212</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p3);</div><div class="line"><a name="l00213"></a><span class="lineno">  213</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p5);</div><div class="line"><a name="l00214"></a><span class="lineno">  214</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p3);</div><div class="line"><a name="l00215"></a><span class="lineno">  215</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p4);</div><div class="line"><a name="l00216"></a><span class="lineno">  216</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00217"></a><span class="lineno">  217</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p4);</div><div class="line"><a name="l00218"></a><span class="lineno">  218</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00219"></a><span class="lineno">  219</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p7);</div><div class="line"><a name="l00220"></a><span class="lineno">  220</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00221"></a><span class="lineno">  221</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p11);</div><div class="line"><a name="l00222"></a><span class="lineno">  222</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p10);</div><div class="line"><a name="l00223"></a><span class="lineno">  223</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p11);</div><div class="line"><a name="l00224"></a><span class="lineno">  224</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p9);</div><div class="line"><a name="l00225"></a><span class="lineno">  225</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p8, p11);</div><div class="line"><a name="l00226"></a><span class="lineno">  226</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p8, p9);</div><div class="line"><a name="l00227"></a><span class="lineno">  227</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p10);</div><div class="line"><a name="l00228"></a><span class="lineno">  228</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00229"></a><span class="lineno">  229</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p10);</div><div class="line"><a name="l00230"></a><span class="lineno">  230</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p6);</div><div class="line"><a name="l00231"></a><span class="lineno">  231</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p10);</div><div class="line"><a name="l00232"></a><span class="lineno">  232</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p6);</div><div class="line"><a name="l00233"></a><span class="lineno">  233</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p8);</div><div class="line"><a name="l00234"></a><span class="lineno">  234</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p4);</div><div class="line"><a name="l00235"></a><span class="lineno">  235</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p8);</div><div class="line"><a name="l00236"></a><span class="lineno">  236</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p7);</div><div class="line"><a name="l00237"></a><span class="lineno">  237</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p11);</div><div class="line"><a name="l00238"></a><span class="lineno">  238</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p7);</div><div class="line"><a name="l00239"></a><span class="lineno">  239</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p9);</div><div class="line"><a name="l00240"></a><span class="lineno">  240</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p5);</div><div class="line"><a name="l00241"></a><span class="lineno">  241</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p9);</div><div class="line"><a name="l00242"></a><span class="lineno">  242</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p2);</div><div class="line"><a name="l00243"></a><span class="lineno">  243</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p4);</div><div class="line"><a name="l00244"></a><span class="lineno">  244</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p6);</div><div class="line"><a name="l00245"></a><span class="lineno">  245</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p8);</div><div class="line"><a name="l00246"></a><span class="lineno">  246</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p10);</div><div class="line"><a name="l00247"></a><span class="lineno">  247</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p14);</div><div class="line"><a name="l00248"></a><span class="lineno">  248</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p12, p13);</div><div class="line"><a name="l00249"></a><span class="lineno">  249</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p14);</div><div class="line"><a name="l00250"></a><span class="lineno">  250</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p16, p17);</div><div class="line"><a name="l00251"></a><span class="lineno">  251</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p15, p16);</div><div class="line"><a name="l00252"></a><span class="lineno">  252</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p16, p17);</div><div class="line"><a name="l00253"></a><span class="lineno">  253</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p12, p15);</div><div class="line"><a name="l00254"></a><span class="lineno">  254</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p14, p17);</div><div class="line"><a name="l00255"></a><span class="lineno">  255</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p14, p15);</div><div class="line"><a name="l00256"></a><span class="lineno">  256</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p16);</div><div class="line"><a name="l00257"></a><span class="lineno">  257</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p14);</div><div class="line"><a name="l00258"></a><span class="lineno">  258</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p15, p16);</div><div class="line"><a name="l00259"></a><span class="lineno">  259</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p19, p20);</div><div class="line"><a name="l00260"></a><span class="lineno">  260</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p18, p19);</div><div class="line"><a name="l00261"></a><span class="lineno">  261</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p19, p20);</div><div class="line"><a name="l00262"></a><span class="lineno">  262</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p21, p22);</div><div class="line"><a name="l00263"></a><span class="lineno">  263</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p23, p24);</div><div class="line"><a name="l00264"></a><span class="lineno">  264</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p21, p23);</div><div class="line"><a name="l00265"></a><span class="lineno">  265</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p22, p24);</div><div class="line"><a name="l00266"></a><span class="lineno">  266</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p22, p23);</div><div class="line"><a name="l00267"></a><span class="lineno">  267</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p18, p21);</div><div class="line"><a name="l00268"></a><span class="lineno">  268</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p20, p23);</div><div class="line"><a name="l00269"></a><span class="lineno">  269</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p20, p21);</div><div class="line"><a name="l00270"></a><span class="lineno">  270</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p19, p22);</div><div class="line"><a name="l00271"></a><span class="lineno">  271</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p22, p24);</div><div class="line"><a name="l00272"></a><span class="lineno">  272</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p19, p20);</div><div class="line"><a name="l00273"></a><span class="lineno">  273</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p21, p22);</div><div class="line"><a name="l00274"></a><span class="lineno">  274</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p23, p24);</div><div class="line"><a name="l00275"></a><span class="lineno">  275</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p12, p18);</div><div class="line"><a name="l00276"></a><span class="lineno">  276</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p16, p22);</div><div class="line"><a name="l00277"></a><span class="lineno">  277</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p16, p18);</div><div class="line"><a name="l00278"></a><span class="lineno">  278</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p14, p20);</div><div class="line"><a name="l00279"></a><span class="lineno">  279</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p20, p24);</div><div class="line"><a name="l00280"></a><span class="lineno">  280</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p14, p16);</div><div class="line"><a name="l00281"></a><span class="lineno">  281</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p18, p20);</div><div class="line"><a name="l00282"></a><span class="lineno">  282</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p22, p24);</div><div class="line"><a name="l00283"></a><span class="lineno">  283</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p19);</div><div class="line"><a name="l00284"></a><span class="lineno">  284</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p17, p23);</div><div class="line"><a name="l00285"></a><span class="lineno">  285</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p17, p19);</div><div class="line"><a name="l00286"></a><span class="lineno">  286</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p15, p21);</div><div class="line"><a name="l00287"></a><span class="lineno">  287</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p15, p17);</div><div class="line"><a name="l00288"></a><span class="lineno">  288</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p19, p21);</div><div class="line"><a name="l00289"></a><span class="lineno">  289</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p14);</div><div class="line"><a name="l00290"></a><span class="lineno">  290</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p15, p16);</div><div class="line"><a name="l00291"></a><span class="lineno">  291</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p17, p18);</div><div class="line"><a name="l00292"></a><span class="lineno">  292</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p19, p20);</div><div class="line"><a name="l00293"></a><span class="lineno">  293</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p21, p22);</div><div class="line"><a name="l00294"></a><span class="lineno">  294</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p23, p24);</div><div class="line"><a name="l00295"></a><span class="lineno">  295</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p0, p12);</div><div class="line"><a name="l00296"></a><span class="lineno">  296</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p8, p20);</div><div class="line"><a name="l00297"></a><span class="lineno">  297</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p8, p12);</div><div class="line"><a name="l00298"></a><span class="lineno">  298</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p4, p16);</div><div class="line"><a name="l00299"></a><span class="lineno">  299</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p16, p24);</div><div class="line"><a name="l00300"></a><span class="lineno">  300</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p12, p16);</div><div class="line"><a name="l00301"></a><span class="lineno">  301</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p2, p14);</div><div class="line"><a name="l00302"></a><span class="lineno">  302</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p22);</div><div class="line"><a name="l00303"></a><span class="lineno">  303</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p14);</div><div class="line"><a name="l00304"></a><span class="lineno">  304</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p18);</div><div class="line"><a name="l00305"></a><span class="lineno">  305</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p6, p10);</div><div class="line"><a name="l00306"></a><span class="lineno">  306</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p10, p12);</div><div class="line"><a name="l00307"></a><span class="lineno">  307</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p1, p13);</div><div class="line"><a name="l00308"></a><span class="lineno">  308</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p21);</div><div class="line"><a name="l00309"></a><span class="lineno">  309</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p9, p13);</div><div class="line"><a name="l00310"></a><span class="lineno">  310</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p5, p17);</div><div class="line"><a name="l00311"></a><span class="lineno">  311</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p13, p17);</div><div class="line"><a name="l00312"></a><span class="lineno">  312</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p3, p15);</div><div class="line"><a name="l00313"></a><span class="lineno">  313</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p11, p23);</div><div class="line"><a name="l00314"></a><span class="lineno">  314</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p11, p15);</div><div class="line"><a name="l00315"></a><span class="lineno">  315</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p19);</div><div class="line"><a name="l00316"></a><span class="lineno">  316</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p7, p11);</div><div class="line"><a name="l00317"></a><span class="lineno">  317</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p11, p13);</div><div class="line"><a name="l00318"></a><span class="lineno">  318</span>&#160;    <a class="code" href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a>(p11, p12);</div><div class="line"><a name="l00319"></a><span class="lineno">  319</span>&#160;    <span class="keywordflow">return</span> p12;</div><div class="line"><a name="l00320"></a><span class="lineno">  320</span>&#160;}</div><div class="line"><a name="l00321"></a><span class="lineno">  321</span>&#160;</div><div class="line"><a name="l00339"></a><span class="lineno"><a class="line" href="non__linear__filter5x5_8cl.xhtml#a41b21a372a22ccea4fc7794e6de9b0cc">  339</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="non__linear__filter5x5_8cl.xhtml#a41b21a372a22ccea4fc7794e6de9b0cc">non_linear_filter_box5x5</a>(</div><div class="line"><a name="l00340"></a><span class="lineno">  340</span>&#160;    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00341"></a><span class="lineno">  341</span>&#160;    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00342"></a><span class="lineno">  342</span>&#160;{</div><div class="line"><a name="l00343"></a><span class="lineno">  343</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00344"></a><span class="lineno">  344</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00345"></a><span class="lineno">  345</span>&#160;</div><div class="line"><a name="l00346"></a><span class="lineno">  346</span>&#160;    <span class="comment">// Load values</span></div><div class="line"><a name="l00347"></a><span class="lineno">  347</span>&#160;    uchar16 top2    = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, -2));</div><div class="line"><a name="l00348"></a><span class="lineno">  348</span>&#160;    uchar16 top     = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, -1));</div><div class="line"><a name="l00349"></a><span class="lineno">  349</span>&#160;    uchar16 middle  = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, 0));</div><div class="line"><a name="l00350"></a><span class="lineno">  350</span>&#160;    uchar16 bottom  = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, 1));</div><div class="line"><a name="l00351"></a><span class="lineno">  351</span>&#160;    uchar16 bottom2 = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, 2));</div><div class="line"><a name="l00352"></a><span class="lineno">  352</span>&#160;</div><div class="line"><a name="l00353"></a><span class="lineno">  353</span>&#160;    <span class="comment">// Apply respective filter</span></div><div class="line"><a name="l00354"></a><span class="lineno">  354</span>&#160;<span class="preprocessor">#if defined   MIN</span></div><div class="line"><a name="l00355"></a><span class="lineno">  355</span>&#160;    uchar16   tmp = min(middle, min(min(top2, top), min(bottom, bottom2)));</div><div class="line"><a name="l00356"></a><span class="lineno">  356</span>&#160;    uchar8    out = <a class="code" href="non__linear__filter__helpers_8h.xhtml#aa9d1bdcaf911a5b861c2082181e6a716">row_reduce_min_5</a>(tmp);</div><div class="line"><a name="l00357"></a><span class="lineno">  357</span>&#160;<span class="preprocessor">#elif defined MAX</span></div><div class="line"><a name="l00358"></a><span class="lineno">  358</span>&#160;    uchar16 tmp = max(middle, max(max(top2, top), max(bottom, bottom2)));</div><div class="line"><a name="l00359"></a><span class="lineno">  359</span>&#160;    uchar8  out = <a class="code" href="non__linear__filter__helpers_8h.xhtml#a310f21b7cf0409431ddf246c4a98e52e">row_reduce_max_5</a>(tmp);</div><div class="line"><a name="l00360"></a><span class="lineno">  360</span>&#160;<span class="preprocessor">#elif defined MEDIAN</span></div><div class="line"><a name="l00361"></a><span class="lineno">  361</span>&#160;    uchar8 out = <a class="code" href="non__linear__filter5x5_8cl.xhtml#ac943e4049581c4aa48abecb270d36fd8">median_box5x5</a>(top2, top, middle, bottom, bottom2);</div><div class="line"><a name="l00362"></a><span class="lineno">  362</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00363"></a><span class="lineno">  363</span>&#160;<span class="preprocessor">#error &quot;Unsupported filter function&quot;</span></div><div class="line"><a name="l00364"></a><span class="lineno">  364</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00365"></a><span class="lineno">  365</span>&#160;</div><div class="line"><a name="l00366"></a><span class="lineno">  366</span>&#160;    <span class="comment">// Store result</span></div><div class="line"><a name="l00367"></a><span class="lineno">  367</span>&#160;    vstore8(out, 0, dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00368"></a><span class="lineno">  368</span>&#160;}</div><div class="line"><a name="l00369"></a><span class="lineno">  369</span>&#160;</div><div class="line"><a name="l00387"></a><span class="lineno"><a class="line" href="non__linear__filter5x5_8cl.xhtml#a55bfb651c4824675a4c1ae1d27cd6d52">  387</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="non__linear__filter5x5_8cl.xhtml#a55bfb651c4824675a4c1ae1d27cd6d52">non_linear_filter_cross5x5</a>(</div><div class="line"><a name="l00388"></a><span class="lineno">  388</span>&#160;    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00389"></a><span class="lineno">  389</span>&#160;    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00390"></a><span class="lineno">  390</span>&#160;{</div><div class="line"><a name="l00391"></a><span class="lineno">  391</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00392"></a><span class="lineno">  392</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00393"></a><span class="lineno">  393</span>&#160;</div><div class="line"><a name="l00394"></a><span class="lineno">  394</span>&#160;    <span class="comment">// Load values</span></div><div class="line"><a name="l00395"></a><span class="lineno">  395</span>&#160;    uchar16 top2    = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, -2));</div><div class="line"><a name="l00396"></a><span class="lineno">  396</span>&#160;    uchar16 top     = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, -1));</div><div class="line"><a name="l00397"></a><span class="lineno">  397</span>&#160;    uchar16 middle  = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, 0));</div><div class="line"><a name="l00398"></a><span class="lineno">  398</span>&#160;    uchar16 bottom  = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 1));</div><div class="line"><a name="l00399"></a><span class="lineno">  399</span>&#160;    uchar16 bottom2 = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, 0, 2));</div><div class="line"><a name="l00400"></a><span class="lineno">  400</span>&#160;</div><div class="line"><a name="l00401"></a><span class="lineno">  401</span>&#160;    <span class="comment">// Apply respective filter</span></div><div class="line"><a name="l00402"></a><span class="lineno">  402</span>&#160;<span class="preprocessor">#if defined   MIN</span></div><div class="line"><a name="l00403"></a><span class="lineno">  403</span>&#160;    uchar8    tmp_middle = <a class="code" href="non__linear__filter__helpers_8h.xhtml#aa9d1bdcaf911a5b861c2082181e6a716">row_reduce_min_5</a>(middle);</div><div class="line"><a name="l00404"></a><span class="lineno">  404</span>&#160;    uchar8    out        = min(tmp_middle, min(min(top2.s01234567, top.s01234567), min(bottom.s01234567, bottom2.s01234567)));</div><div class="line"><a name="l00405"></a><span class="lineno">  405</span>&#160;<span class="preprocessor">#elif defined MAX</span></div><div class="line"><a name="l00406"></a><span class="lineno">  406</span>&#160;    uchar8  tmp_middle = <a class="code" href="non__linear__filter__helpers_8h.xhtml#a310f21b7cf0409431ddf246c4a98e52e">row_reduce_max_5</a>(middle);</div><div class="line"><a name="l00407"></a><span class="lineno">  407</span>&#160;    uchar8  out        = max(tmp_middle, max(max(top2.s01234567, top.s01234567), max(bottom.s01234567, bottom2.s01234567)));</div><div class="line"><a name="l00408"></a><span class="lineno">  408</span>&#160;<span class="preprocessor">#elif defined MEDIAN</span></div><div class="line"><a name="l00409"></a><span class="lineno">  409</span>&#160;    uchar8 p0  = top2.s01234567;</div><div class="line"><a name="l00410"></a><span class="lineno">  410</span>&#160;    uchar8 p1  = top.s01234567;</div><div class="line"><a name="l00411"></a><span class="lineno">  411</span>&#160;    uchar8 p2  = middle.s01234567;</div><div class="line"><a name="l00412"></a><span class="lineno">  412</span>&#160;    uchar8 p3  = middle.s12345678;</div><div class="line"><a name="l00413"></a><span class="lineno">  413</span>&#160;    uchar8 p4  = middle.s23456789;</div><div class="line"><a name="l00414"></a><span class="lineno">  414</span>&#160;    uchar8 p5  = middle.s3456789A;</div><div class="line"><a name="l00415"></a><span class="lineno">  415</span>&#160;    uchar8 p6  = middle.s456789AB;</div><div class="line"><a name="l00416"></a><span class="lineno">  416</span>&#160;    uchar8 p7  = bottom.s01234567;</div><div class="line"><a name="l00417"></a><span class="lineno">  417</span>&#160;    uchar8 p8  = bottom2.s01234567;</div><div class="line"><a name="l00418"></a><span class="lineno">  418</span>&#160;    uchar8 out = <a class="code" href="non__linear__filter__helpers_8h.xhtml#a0960df49e39a9499677066c32600c17f">sort9</a>(p0, p1, p2, p3, p4, p5, p6, p7, p8);</div><div class="line"><a name="l00419"></a><span class="lineno">  419</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00420"></a><span class="lineno">  420</span>&#160;<span class="preprocessor">#error &quot;Unsupported filter function&quot;</span></div><div class="line"><a name="l00421"></a><span class="lineno">  421</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00422"></a><span class="lineno">  422</span>&#160;</div><div class="line"><a name="l00423"></a><span class="lineno">  423</span>&#160;    <span class="comment">// Store result</span></div><div class="line"><a name="l00424"></a><span class="lineno">  424</span>&#160;    vstore8(out, 0, dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00425"></a><span class="lineno">  425</span>&#160;}</div><div class="line"><a name="l00426"></a><span class="lineno">  426</span>&#160;</div><div class="line"><a name="l00444"></a><span class="lineno"><a class="line" href="non__linear__filter5x5_8cl.xhtml#a51c3020615fa62c7524d316ba1019a58">  444</a></span>&#160;__kernel <span class="keywordtype">void</span> <a class="code" href="non__linear__filter5x5_8cl.xhtml#a51c3020615fa62c7524d316ba1019a58">non_linear_filter_disk5x5</a>(</div><div class="line"><a name="l00445"></a><span class="lineno">  445</span>&#160;    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(src),</div><div class="line"><a name="l00446"></a><span class="lineno">  446</span>&#160;    <a class="code" href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a>(dst))</div><div class="line"><a name="l00447"></a><span class="lineno">  447</span>&#160;{</div><div class="line"><a name="l00448"></a><span class="lineno">  448</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> src = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(src);</div><div class="line"><a name="l00449"></a><span class="lineno">  449</span>&#160;    <a class="code" href="struct_image.xhtml">Image</a> dst = <a class="code" href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a>(dst);</div><div class="line"><a name="l00450"></a><span class="lineno">  450</span>&#160;</div><div class="line"><a name="l00451"></a><span class="lineno">  451</span>&#160;    <span class="comment">// Load values</span></div><div class="line"><a name="l00452"></a><span class="lineno">  452</span>&#160;    uchar16 top2    = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -1, -2));</div><div class="line"><a name="l00453"></a><span class="lineno">  453</span>&#160;    uchar16 top     = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, -1));</div><div class="line"><a name="l00454"></a><span class="lineno">  454</span>&#160;    uchar16 middle  = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, 0));</div><div class="line"><a name="l00455"></a><span class="lineno">  455</span>&#160;    uchar16 bottom  = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -2, 1));</div><div class="line"><a name="l00456"></a><span class="lineno">  456</span>&#160;    uchar16 bottom2 = vload16(0, <a class="code" href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a>(&amp;src, -1, 2));</div><div class="line"><a name="l00457"></a><span class="lineno">  457</span>&#160;</div><div class="line"><a name="l00458"></a><span class="lineno">  458</span>&#160;    <span class="comment">// Apply respective filter</span></div><div class="line"><a name="l00459"></a><span class="lineno">  459</span>&#160;<span class="preprocessor">#if defined   MIN</span></div><div class="line"><a name="l00460"></a><span class="lineno">  460</span>&#160;    uchar16   tmp_3     = min(top2, bottom2);</div><div class="line"><a name="l00461"></a><span class="lineno">  461</span>&#160;    uchar16   tmp_5     = min(middle, min(top, bottom));</div><div class="line"><a name="l00462"></a><span class="lineno">  462</span>&#160;    uchar8    tmp_3_red = <a class="code" href="non__linear__filter__helpers_8h.xhtml#ae3e09114bb887de4e20122eed42671a1">row_reduce_min_3</a>(tmp_3);</div><div class="line"><a name="l00463"></a><span class="lineno">  463</span>&#160;    uchar8    tmp_5_red = <a class="code" href="non__linear__filter__helpers_8h.xhtml#aa9d1bdcaf911a5b861c2082181e6a716">row_reduce_min_5</a>(tmp_5);</div><div class="line"><a name="l00464"></a><span class="lineno">  464</span>&#160;    uchar8    out       = min(tmp_3_red, tmp_5_red);</div><div class="line"><a name="l00465"></a><span class="lineno">  465</span>&#160;<span class="preprocessor">#elif defined MAX</span></div><div class="line"><a name="l00466"></a><span class="lineno">  466</span>&#160;    uchar16 tmp_3      = max(top2, bottom2);</div><div class="line"><a name="l00467"></a><span class="lineno">  467</span>&#160;    uchar16 tmp_5      = max(middle, max(top, bottom));</div><div class="line"><a name="l00468"></a><span class="lineno">  468</span>&#160;    uchar8  tmp_3_red  = <a class="code" href="non__linear__filter__helpers_8h.xhtml#a3138dafa8474a59f73dd837073f18ed7">row_reduce_max_3</a>(tmp_3);</div><div class="line"><a name="l00469"></a><span class="lineno">  469</span>&#160;    uchar8  tmp_5_red  = <a class="code" href="non__linear__filter__helpers_8h.xhtml#a310f21b7cf0409431ddf246c4a98e52e">row_reduce_max_5</a>(tmp_5);</div><div class="line"><a name="l00470"></a><span class="lineno">  470</span>&#160;    uchar8  out        = max(tmp_3_red, tmp_5_red);</div><div class="line"><a name="l00471"></a><span class="lineno">  471</span>&#160;<span class="preprocessor">#elif defined MEDIAN</span></div><div class="line"><a name="l00472"></a><span class="lineno">  472</span>&#160;    uchar8 out = <a class="code" href="non__linear__filter5x5_8cl.xhtml#a8a1966a000958e0d48cdc182da9c8bdf">median_disk5x5</a>(top2, top, middle, bottom, bottom2);</div><div class="line"><a name="l00473"></a><span class="lineno">  473</span>&#160;<span class="preprocessor">#else</span></div><div class="line"><a name="l00474"></a><span class="lineno">  474</span>&#160;<span class="preprocessor">#error &quot;Unsupported filter function&quot;</span></div><div class="line"><a name="l00475"></a><span class="lineno">  475</span>&#160;<span class="preprocessor">#endif</span></div><div class="line"><a name="l00476"></a><span class="lineno">  476</span>&#160;</div><div class="line"><a name="l00477"></a><span class="lineno">  477</span>&#160;    <span class="comment">// Store result</span></div><div class="line"><a name="l00478"></a><span class="lineno">  478</span>&#160;    vstore8(out, 0, dst.<a class="code" href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">ptr</a>);</div><div class="line"><a name="l00479"></a><span class="lineno">  479</span>&#160;}</div><div class="ttc" id="non__linear__filter__helpers_8h_xhtml_aa9d1bdcaf911a5b861c2082181e6a716"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#aa9d1bdcaf911a5b861c2082181e6a716">row_reduce_min_5</a></div><div class="ttdeci">uchar8 row_reduce_min_5(uchar16 val)</div><div class="ttdoc">Calculate the minimum of a sliding window of size 5. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00131">non_linear_filter_helpers.h:131</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_ac226bc1ed04fd7d4865263484ed22a47"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#ac226bc1ed04fd7d4865263484ed22a47">SORT</a></div><div class="ttdeci">#define SORT(a, b)</div><div class="ttdoc">Sorts element-wise two vectors. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00030">non_linear_filter_helpers.h:30</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a22f42fcf2077d951271df83b55c1a71a"><div class="ttname"><a href="helpers_8h.xhtml#a22f42fcf2077d951271df83b55c1a71a">IMAGE_DECLARATION</a></div><div class="ttdeci">#define IMAGE_DECLARATION(name)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00049">helpers.h:49</a></div></div>
<div class="ttc" id="non__linear__filter5x5_8cl_xhtml_a55bfb651c4824675a4c1ae1d27cd6d52"><div class="ttname"><a href="non__linear__filter5x5_8cl.xhtml#a55bfb651c4824675a4c1ae1d27cd6d52">non_linear_filter_cross5x5</a></div><div class="ttdeci">__kernel void non_linear_filter_cross5x5(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This function applies a non linear filter on a 5x5 cross basis on an input image. ...</div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter5x5_8cl_source.xhtml#l00387">non_linear_filter5x5.cl:387</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_a310f21b7cf0409431ddf246c4a98e52e"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#a310f21b7cf0409431ddf246c4a98e52e">row_reduce_max_5</a></div><div class="ttdeci">uchar8 row_reduce_max_5(uchar16 val)</div><div class="ttdoc">Calculate the maximum of a sliding window of size 5. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00142">non_linear_filter_helpers.h:142</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_a009469e4d9b8fce3b6d5e97d2077827d"><div class="ttname"><a href="helpers_8h.xhtml#a009469e4d9b8fce3b6d5e97d2077827d">offset</a></div><div class="ttdeci">__global uchar * offset(const Image *img, int x, int y)</div><div class="ttdoc">Get the pointer position of a Image. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00201">helpers.h:201</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml">non_linear_filter_helpers.h</a></div></div>
<div class="ttc" id="helpers_8h_xhtml"><div class="ttname"><a href="helpers_8h.xhtml">helpers.h</a></div></div>
<div class="ttc" id="helpers_8h_xhtml_aebe814363556c244be043b13e7969197"><div class="ttname"><a href="helpers_8h.xhtml#aebe814363556c244be043b13e7969197">CONVERT_TO_IMAGE_STRUCT</a></div><div class="ttdeci">#define CONVERT_TO_IMAGE_STRUCT(name)</div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00073">helpers.h:73</a></div></div>
<div class="ttc" id="non__linear__filter5x5_8cl_xhtml_ac943e4049581c4aa48abecb270d36fd8"><div class="ttname"><a href="non__linear__filter5x5_8cl.xhtml#ac943e4049581c4aa48abecb270d36fd8">median_box5x5</a></div><div class="ttdeci">uchar8 median_box5x5(uchar16 top2, uchar16 top, uchar16 middle, uchar16 bottom, uchar16 bottom2)</div><div class="ttdoc">Sorting network to sort 8 boxes of size 5 and return their median. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter5x5_8cl_source.xhtml#l00178">non_linear_filter5x5.cl:178</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_a3138dafa8474a59f73dd837073f18ed7"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#a3138dafa8474a59f73dd837073f18ed7">row_reduce_max_3</a></div><div class="ttdeci">uchar8 row_reduce_max_3(uchar16 val)</div><div class="ttdoc">Calculate the maximum of a sliding window of size 3. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00120">non_linear_filter_helpers.h:120</a></div></div>
<div class="ttc" id="struct_image_xhtml"><div class="ttname"><a href="struct_image.xhtml">Image</a></div><div class="ttdoc">Structure to hold Image information. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00095">helpers.h:95</a></div></div>
<div class="ttc" id="struct_image_xhtml_acf52c23cbd7424606c10a606524e3e32"><div class="ttname"><a href="struct_image.xhtml#acf52c23cbd7424606c10a606524e3e32">Image::ptr</a></div><div class="ttdeci">__global uchar * ptr</div><div class="ttdoc">Pointer to the starting postion of the buffer. </div><div class="ttdef"><b>Definition:</b> <a href="helpers_8h_source.xhtml#l00097">helpers.h:97</a></div></div>
<div class="ttc" id="non__linear__filter5x5_8cl_xhtml_a51c3020615fa62c7524d316ba1019a58"><div class="ttname"><a href="non__linear__filter5x5_8cl.xhtml#a51c3020615fa62c7524d316ba1019a58">non_linear_filter_disk5x5</a></div><div class="ttdeci">__kernel void non_linear_filter_disk5x5(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This function applies a non linear filter on a 5x5 disk basis on an input image. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter5x5_8cl_source.xhtml#l00444">non_linear_filter5x5.cl:444</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_a0960df49e39a9499677066c32600c17f"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#a0960df49e39a9499677066c32600c17f">sort9</a></div><div class="ttdeci">uchar8 sort9(uchar8 p0, uchar8 p1, uchar8 p2, uchar8 p3, uchar8 p4, uchar8 p5, uchar8 p6, uchar8 p7, uchar8 p8)</div><div class="ttdoc">Sorting network to sort 9 vectors of 8 elements and return their median. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00078">non_linear_filter_helpers.h:78</a></div></div>
<div class="ttc" id="non__linear__filter5x5_8cl_xhtml_a41b21a372a22ccea4fc7794e6de9b0cc"><div class="ttname"><a href="non__linear__filter5x5_8cl.xhtml#a41b21a372a22ccea4fc7794e6de9b0cc">non_linear_filter_box5x5</a></div><div class="ttdeci">__kernel void non_linear_filter_box5x5(__global uchar *src_ptr, uint src_stride_x, uint src_step_x, uint src_stride_y, uint src_step_y, uint src_offset_first_element_in_bytes, __global uchar *dst_ptr, uint dst_stride_x, uint dst_step_x, uint dst_stride_y, uint dst_step_y, uint dst_offset_first_element_in_bytes)</div><div class="ttdoc">This function applies a non linear filter on a 5x5 box basis on an input image. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter5x5_8cl_source.xhtml#l00339">non_linear_filter5x5.cl:339</a></div></div>
<div class="ttc" id="non__linear__filter__helpers_8h_xhtml_ae3e09114bb887de4e20122eed42671a1"><div class="ttname"><a href="non__linear__filter__helpers_8h.xhtml#ae3e09114bb887de4e20122eed42671a1">row_reduce_min_3</a></div><div class="ttdeci">uchar8 row_reduce_min_3(uchar16 val)</div><div class="ttdoc">Calculate the minimum of a sliding window of size 3. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter__helpers_8h_source.xhtml#l00109">non_linear_filter_helpers.h:109</a></div></div>
<div class="ttc" id="non__linear__filter5x5_8cl_xhtml_a8a1966a000958e0d48cdc182da9c8bdf"><div class="ttname"><a href="non__linear__filter5x5_8cl.xhtml#a8a1966a000958e0d48cdc182da9c8bdf">median_disk5x5</a></div><div class="ttdeci">uchar8 median_disk5x5(uchar16 top2, uchar16 top, uchar16 middle, uchar16 bottom, uchar16 bottom2)</div><div class="ttdoc">Sorting network to sort 8 disks of diameter 5 and return their median. </div><div class="ttdef"><b>Definition:</b> <a href="non__linear__filter5x5_8cl_source.xhtml#l00039">non_linear_filter5x5.cl:39</a></div></div>
</div><!-- fragment --></div><!-- contents -->
</div><!-- doc-content -->
<!-- start footer part -->
<div id="nav-path" class="navpath"><!-- id is needed for treeview function! -->
  <ul>
    <li class="navelem"><a class="el" href="dir_68267d1309a1af8e8297ef4c3efbcdba.xhtml">src</a></li><li class="navelem"><a class="el" href="dir_aebb8dcc11953d78e620bbef0b9e2183.xhtml">core</a></li><li class="navelem"><a class="el" href="dir_8c278f79c760e5c5fbd911f9870614c1.xhtml">CL</a></li><li class="navelem"><a class="el" href="dir_25885286e9dad4fa105b7b25a8031bbf.xhtml">cl_kernels</a></li><li class="navelem"><a class="el" href="non__linear__filter5x5_8cl.xhtml">non_linear_filter5x5.cl</a></li>
    <li class="footer">Generated on Wed Apr 12 2017 17:30:09 for ARM Compute Library by
    <a href="http://www.doxygen.org/index.html">
    <img class="footer" src="doxygen.png" alt="doxygen"/></a> 1.8.11 </li>
  </ul>
</div>
</body>
</html>
